
-- run SpaceStat purge routine to delete old unnecessary space usage statistic
-- version 0.54 (2012.10.16)
-- Parameters: all optional, but can be provided


set serveroutput on;

column snaps_cnt format a25
select 'snaps before purge:'||count(1) snaps_cnt from SPACESTAT.SPS_SNAPS;

/* 
If retention policy settings are set using cfg/cfg_settings.sql
then no parameters are required.
*/

exec SPACESTAT.SPS_PURGE();
-- commit is mandatory here (if all OK).
commit;

/* 
In special cases parameters can be provided 
in postional way (one by one) 
or as named values like:
  exec SPACESTAT.SPS_PURGE(p_check_retention_cfg=>true,p_dbid=>10101010101);
  exec SPACESTAT.SPS_PURGE(p_check_retention_cfg=>false,p_keep_num_days=>90);

Parameters are:
      p_check_retention_cfg IN boolean default true
      , p_begin_snap_id     IN number default null
      , p_end_snap_id       IN number default null
      , p_begin_date        IN date default null 
      , p_end_date          IN date default null
      , p_purge_before_date IN date default null
      , p_keep_num_days     IN number default null  -- how many days to keep data
      , p_dbid              IN number default null  -- used when db was cloned or DBID changed with nid
*/


-- check purge done
select ' snaps after purge:'||count(1) snaps_cnt from SPACESTAT.SPS_SNAPS;
---



