/* upgrade SPACESTAT objects
from version: 0.53
  to version: 0.54
  
 date: 2012.10.16
*/   

-- check existing
set lines 300
set pages 100

select * from SPACESTAT.SPS_VERSION;
-- create table if not exists (due to bug in 0.53 published version, fixed in 0.53.1) 
create table SPACESTAT.SPS_VERSION(module_name varchar2(30),
  module_info varchar2(255), 
  module_version varchar(8),
  status varchar2(7),
  install_ts DATE, 
  upgrade_ts DATE
) tablespace SPACESTAT
/

insert into SPACESTAT.SPS_VERSION(module_name,module_info,module_version,status,install_ts,upgrade_ts)
  values('SPS_ORADB','SpaceStat for Oracle DB','0.54','upgrade',sysdate,sysdate);
commit;   

--- tables --
-- table with SpaceStat settings
create table SPACESTAT.SPS_SETTINGS(
  NAME  VARCHAR2(64)
, VALUE VARCHAR2(512)
, DESCRIPTION VARCHAR2(512)
) tablespace SPACESTAT
/
---- UK-PK-Index
CREATE UNIQUE INDEX SPACESTAT.SPS_SETT_PK ON SPACESTAT.SPS_SETTINGS (
  NAME
) tablespace SPACESTAT
/
-- PK constraint
alter table SPACESTAT.SPS_SETTINGS 
add constraint SPS_SETT_PK primary key(
  NAME
)
USING INDEX tablespace SPACESTAT
/

-- load default settings
@create\cre_settings.sql
@create\cre_views.sql
-------------
-- create new code
@create\cre_code_snap.sql
@create\cre_code_purge.sql

-- when completed
update SPACESTAT.SPS_VERSION set status='VALID',upgrade_ts=sysdate 
 where module_name='SPS_ORADB' and module_version='0.54'
   and status='upgrade';
commit;

/* Installation done
  next: check for invalid objects
*/
col OBJECT_TYPE format a16
col OBJECT_NAME format a30
col STATUS format a10  

select OBJECT_TYPE, OBJECT_NAME, STATUS 
  from dba_objects 
 where owner='SPACESTAT'
order by STATUS, OBJECT_TYPE, OBJECT_NAME;

/* next: 
  update scripts at OS used for scheduled snapshoting: use ALL or DBS,DBF 
*/  