
/*
  CoMinder SpaceStat Installation - Settings
  ver.: 0.54
*/
/* 
-- uncomment when required 
truncate table SPACESTAT.SPS_SETTINGS; 
*/

-- insert some default values
-- count of snapshots to keep for each period-type
insert into SPACESTAT.SPS_SETTINGS(NAME,VALUE,DESCRIPTION) 
values ('RETENTION_KEEP_DAILY_DATA_COUNT','62','How many days to keep daily snapshots'); 

insert into SPACESTAT.SPS_SETTINGS(NAME,VALUE,DESCRIPTION) 
values ('RETENTION_KEEP_WEEKLY_DATA_COUNT','53','How many weeks to keep weekly snapshots'); 

insert into SPACESTAT.SPS_SETTINGS(NAME,VALUE,DESCRIPTION) 
values ('RETENTION_KEEP_MONTHLY_DATA_COUNT','24','How many months to keep monthly snapshots'); 

insert into SPACESTAT.SPS_SETTINGS(NAME,VALUE,DESCRIPTION) 
values ('RETENTION_KEEP_YEARLY_DATA_COUNT','5','How many years to keep yearly snapshots'); 

-- day of snapshot, if NULL - this snapshot periods not processed and may be purged during next purge
-- daily - ignore, we have only one day per day :)

-- weekly: MON,TUE,WED,THU,FRI,SAT,SUN
insert into SPACESTAT.SPS_SETTINGS(NAME,VALUE,DESCRIPTION) 
values ('RETENTION_KEEP_WEEKLY_DATA_DAY','SUN','Which week day data to keep for weekly snapshots');

-- monthly: FIRST,LAST or exact date 01-28, values 29-31 not supported, use LAST instead
insert into SPACESTAT.SPS_SETTINGS(NAME,VALUE,DESCRIPTION) 
values ('RETENTION_KEEP_MONTHLY_DATA_DAY','01','Which month day data to keep for monthly snapshots'); 

-- yearly: FIRST,LAST or exact date in format DD.MM, values 29-31.MM not supported 
insert into SPACESTAT.SPS_SETTINGS(NAME,VALUE,DESCRIPTION) 
values ('RETENTION_KEEP_YEARLY_DATA_DAY','01.01','Which year day data to keep for yearly snapshots'); 

commit;

col NAME format a40
col VALUE format a10
col DESCRIPTION format a60
select * from SPACESTAT.SPS_SETTINGS order by NAME;

