
set lines 400
set pages 2000
set feedb off verify off

ACCEPT p_date_start PROMPT "Please specify reporting date start in format of YYYY.MM.DD: "
ACCEPT p_date_end   PROMPT "Please specify reporting date  end  in format of YYYY.MM.DD: "

prompt ========= Database Files Size Dynamic ==============
col CTL format 999990.999
col REDO format 999990.999
col UNDO format 999990.999
col TEMP format 999990.999
col DATA format 999990.999
col DB_FILE_GB format 999990.999

select S.SNAP_ID, S.start_time SNAP_TS, 
sum(BYTES)/1024/1024/1024 DB_FILE_GB,
sum(CASE WHEN SD.SEGMENT_TYPE = 'CONTROL_FILE' then BYTES ELSE 0 END)/1024/1024/1024 as CTL,
sum(CASE WHEN SD.SEGMENT_TYPE = 'REDOLOG_FILE' then BYTES ELSE 0 END)/1024/1024/1024 as REDO,
sum(CASE WHEN SD.SEGMENT_TYPE = 'UNDO_FILE' then BYTES ELSE 0 END)/1024/1024/1024 as UNDO, 
sum(CASE WHEN SD.SEGMENT_TYPE = 'TEMP_FILE' then BYTES ELSE 0 END)/1024/1024/1024 as TEMP,
sum(CASE WHEN SD.SEGMENT_TYPE = 'DATA_FILE' then BYTES ELSE 0 END)/1024/1024/1024 as DATA
 from SPACESTAT.SPS_SNAP_DATA SD 
      inner join SPACESTAT.SPS_SNAPS S on (S.SNAP_ID=SD.SNAP_ID and S.SNAP_TYPE=S.SNAP_TYPE)
 where (S.SNAP_TYPE='DBF' or S.SNAP_TYPE='F')
  and S.start_time  BETWEEN to_date('&p_date_start','YYYY.MM.DD') and to_date('&p_date_end','YYYY.MM.DD')
group by S.SNAP_ID, S.start_time   
/         


prompt ========= Database Segments Size Dynamic ============== 

prompt SEGMENT_TYPE       COLUMN  
prompt ************************** 
prompt TABLE               TBL 
prompt INDEX               IND
prompt LOBSEGMENT          LOBS 
prompt LOBINDEX            LOBI 
prompt TABLE PARTITION     TBLP
prompt INDEX PARTITION     INDP 
prompt LOB PARTITION       LOBP
prompt NESTED TABLE        NEST 
prompt TYPE2 UNDO          UNDO
prompt ROLLBACK            RLB 
prompt CACHE               CCH 
prompt CLUSTER             CLST 
 


col TBL format 999990.999
col IND format 999990.999
col TBLP format 999990.99999
col INDP format 999990.99999
col LOBS format 999990.999
col LOBI format 999990.999
col LOBP format 999990.99999
col CLST format 999990.99999
col NEST format 999990.99999
col UNDO format 999990.999
col RLB format 999990.99999
col CCH format 999990.99999
col DB_SEGS_GB format 999990.999

select S.SNAP_ID, S.start_time SNAP_TS, 
sum(BYTES)/1024/1024/1024 DB_SEGS_GB,
sum(CASE WHEN SD.SEGMENT_TYPE = 'TABLE' then BYTES ELSE 0 END)/1024/1024/1024 as TBL,
sum(CASE WHEN SD.SEGMENT_TYPE = 'INDEX' then BYTES ELSE 0 END)/1024/1024/1024 as IND,
sum(CASE WHEN SD.SEGMENT_TYPE = 'TABLE PARTITION' then BYTES ELSE 0 END)/1024/1024/1024 as TBLP,
sum(CASE WHEN SD.SEGMENT_TYPE = 'INDEX PARTITION' then BYTES ELSE 0 END)/1024/1024/1024 as INDP,
sum(CASE WHEN SD.SEGMENT_TYPE = 'LOBSEGMENT' then BYTES ELSE 0 END)/1024/1024/1024 as LOBS,
sum(CASE WHEN SD.SEGMENT_TYPE = 'LOBINDEX' then BYTES ELSE 0 END)/1024/1024/1024 as LOBI,
sum(CASE WHEN SD.SEGMENT_TYPE = 'LOB PARTITION' then BYTES ELSE 0 END)/1024/1024/1024 as LOBP,
sum(CASE WHEN SD.SEGMENT_TYPE = 'CLUSTER' then BYTES ELSE 0 END)/1024/1024/1024 as CLST,
sum(CASE WHEN SD.SEGMENT_TYPE = 'NESTED TABLE' then BYTES ELSE 0 END)/1024/1024/1024 as NEST,
sum(CASE WHEN SD.SEGMENT_TYPE = 'TYPE2 UNDO' then BYTES ELSE 0 END)/1024/1024/1024 as UNDO,
sum(CASE WHEN SD.SEGMENT_TYPE = 'ROLLBACK' then BYTES ELSE 0 END)/1024/1024/1024 as RLB,
sum(CASE WHEN SD.SEGMENT_TYPE = 'CACHE' then BYTES ELSE 0 END)/1024/1024/1024 as CCH
 from SPACESTAT.SPS_SNAP_DATA SD 
      inner join SPACESTAT.SPS_SNAPS S on (S.SNAP_ID=SD.SNAP_ID and S.SNAP_TYPE=S.SNAP_TYPE)
 where (S.SNAP_TYPE='DBS' or S.SNAP_TYPE='S')
  and S.start_time  BETWEEN to_date('&p_date_start','YYYY.MM.DD') and to_date('&p_date_end','YYYY.MM.DD')
group by S.SNAP_ID, S.start_time   
/         
  

