--
-- show top segments by used bytes
-- version 0.54 (2012.09.04)
-- changes:
-- 2012.09.04: 0.54: ACE: 1st issue
-- 2013.04.12: 0.55: ACE: add summary by segment not by partition 


SET SERVEROUTPUT ON VERIFY OFF

--   SELECT DBAACE.SPSTAT_SNAP_ID_SEQ.NEXTVAL INTO snap_nextval FROM dual;
set lines 300
set pages 1000
@@sps_list_snaps.sql

--ACCEPT new_id PROMPT "Please enter SNAP_ID value: "
prompt Specify the Begin and/or End Snapshot Ids where required
prompt ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
prompt End   Snapshot Id specified: &&end_snap_seg
prompt

variable eid        number;
begin
  :eid       :=  &end_snap_seg;
end;
/


VARIABLE  snap_2_info varchar2(255);
VARIABLE  skip_schema varchar2(255);
--:skip_schema = 'where OWNER not in ('SYS','SYSTEM','XDB','WMSYS') ' 
begin
  SELECT snap_id||' '||DB_NAME||' '||TO_CHAR(start_time, 'DD-MM-YYYY HH24:MI:SS') into :snap_2_info
  FROM SPACESTAT.SPS_SNAPS where snap_id=:eid;
end;
/

set lines 3000
set pages 10000
set feed off
exec DBMS_OUTPUT.PUT_LINE('=== Top 100 SEGMENTS existing in '||:snap_2_info||' ===');
set feed on
column OWNER FORMAT a15
column SEGMENT_TYPE FORMAT a15
column SEGMENT_NAME FORMAT a50
column TABLESPACE_NAME FORMAT a30
column MBYTES FORMAT 99999999.99
column PCT format 990.99 
select rownum, TOT.* from (
select B.OWNER, B.SEGMENT_TYPE, B.SEGMENT_NAME, B.TABLESPACE_NAME, 
       sum(B.BYTES)/1024/1024 MBYTES, sum(B.BYTES)/S.SBYTES*100 PCT 
  from SPACESTAT.SPS_SNAP_DATA B, 
      (select sum(bytes) SBYTES from SPACESTAT.SPS_SNAP_DATA S where S.SNAP_ID=:eid) S 
 where B.SNAP_ID=:eid
group by B.OWNER, B.SEGMENT_TYPE, B.SEGMENT_NAME, B.TABLESPACE_NAME, S.SBYTES 
 -- and B.OWNER not in ('SYS','SYSTEM','XDB','WMSYS')
order by sum(B.BYTES) DESC, B.OWNER, B.SEGMENT_TYPE, B.SEGMENT_NAME
) TOT where rownum<101  
/


